Modifications made on files provided by KKM (in the TestA?.zip files):
* TestA?/Params.f90:
  - renamed to Params.F90 (with a capital "F"), so that gfortran passes it through the C preprocessor
  - replaced the values of N, d, q by expressions containing the "COUNTRIES" macro
* TestA8/Test.f90:
  - renamed procedure "Test1" to "Test", in order to be consistent with the other Test.f90 files

!**********************************************************************************
!
!	SUBROUTINE: Test
!
!	PURPOSE: Takes as input state variable and returns as output all variables
!                 for the current period.
!			 
!	AUTHOR:	 Ben Malin 
!
!	DATE:    11/2007
!**********************************************************************************

subroutine Test(state,control)
  
  ! inputs:
  !   state -- vector of dimension 2*N, contains state variables k and ln(a)
  !
  ! output:
  !   control -- vector of dimension 3*N, contains k', c, and y 
  !
  ! remarks:
  !
  
  use Params

  implicit none
  
  !Variable Declarations
  real(prec),dimension(2*N),intent(in) :: state
  real(prec),dimension(3*N),intent(out) :: control
  integer :: i,j	
  real(prec),dimension(5,2*N) :: Ttemp
 
  !Function used to calculate optimal policy functions (either consumption or capital) given state 
  real(prec),external :: ChebValue

  !Read in state variables
  do i = 1,N
     SimCapital(i) = state(i)
     shock(i) = state(N+i)
  end do
  call ChebPoly(d, state, Ttemp)

  !Compute consumption, output and tomorrow's cap stock for each country
  do i = 1,N
     SimCapTom(i) = ChebValue(Ttemp,CoeffsCap1(:,:,i), &
          & CoeffsCap2(:,:,:,:,i),CoeffsCap3(:,:,i),YCap0(i))
     SimConsumption(i) = ChebValue(Ttemp,CoeffsCons1(:,:,i), &
          & CoeffsCons2(:,:,:,:,i),CoeffsCons3(:,:,i),YCons0(i))
     SimOutput(i) = F(SimCapital(i),shock(i))
  enddo
  
  do i = 1,N
     control(i) = SimCapTom(i)
     control(N+i) = SimConsumption(i)
     control(2*N+i) = SimOutput(i)
  end do

end subroutine Test

!**********************************************************************************
!
!	SUBROUTINE:  ChebPoly
!
!	PURPOSE: Converts a vector of state variables from the [kmin,kmax] x N grid (or 
!                 [kmin,kmax]/[zmin,zmax] x d grid) to the [-1,1] x N (or d) grid 
!                and returns the Chebyshev polynomials for these state variables.
!                This subroutine works in conjunction with ChebValue.
!**********************************************************************************

subroutine ChebPoly(dim1,state,Ttemp)
  
  ! inputs:
  !    dim1 -- dimension of "state" vector
  !    state -- vector of capital stocks and, possibly, technology shocks
  !
  ! output:
  !    Ttemp -- Chebyshev polynomials evaluated at points in state vector
  ! 
  ! remarks:
  !

  use Params
  
  implicit none
  
  !Variable Declaration
  integer, intent(in) :: dim1
  real(prec), dimension(dim1), intent(in) :: state
  real(prec), dimension(2**(q-d)+1,dim1), intent(out) :: Ttemp
  real(prec), dimension(dim1) :: newstate
  integer :: i,j
  
  do i = 1,N
     !Convert capital stock [-1,1] grid
     newstate(i) = 2.0 * (state(i) - kmin)/(kmax-kmin) - 1.0	!kmax, kmin are global variables
     
!     if (newstate(i) < -1) then
!        print*, 'error: capital below kmin in function ChebPoly',i
!        pause
!     elseif (newstate(i) > 1) then
!        print*, 'error: capital above kmax in function ChebPoly',i
!        pause
!     end if
     
     !Construct Chebyshev Polynomials for capital stocks
     Ttemp(1,i) = 1
     Ttemp(2,i) = newstate(i)
     do j = 3,5			!Since q = d+2, 2**(q-d)+1 = 5.
        Ttemp(j,i) = 2.0 * newstate(i) * Ttemp(j-1,i) - Ttemp(j-2,i)
     end do
     
     !Convert technological shocks to [-1,1] grid
     if (dim1 == d) then
        newstate(i+N) = 2.0 * (state(i+N) - zmin)/(zmax-zmin) - 1.0	!zmax, zmin are global variables
        
!        if (newstate(i+N) < -1) then
!           print*, 'error: tech shock below zmin in function ChebPoly'
!           pause
!        elseif (newstate(i+N) > 1) then
!           print*, 'error: tech shock above zmax in function ChebPoly'
!           pause
!        end if
        
        !Construct Chebyshev Polynomials for tech shocks
        Ttemp(1,i+N) = 1
        Ttemp(2,i+N) = newstate(i+N)
        do j = 3,5	!Since q = d+2, 2**(q-d)+1 = 5.
           Ttemp(j,i+N) = 2.0 * newstate(i+N) * Ttemp(j-1,i+N) - Ttemp(j-2,i+N)
        end do
     endif
  end do
  
end subroutine ChebPoly

!**********************************************************************************
!
!	FUNCTION:  ChebValue
!
!	PURPOSE: Given the state variables, returns the value of the 
!                 policy function.
!**********************************************************************************

function ChebValue(Ttemp,tempCoeffs1,tempCoeffs2,tempCoeffs3,ChebValueOrigin)
  
  ! inputs:
  !    Ttemp -- Chebyshev polynomials of state variables
  !    tempCoeffs1 -- coefficients of policy function
  !    tempCoeffs2 -- coefficients of policy function
  !    tempCoeffs3 -- coefficients of policy function
  !    ChebValueOrigin -- coefficient of policy function
  !
  ! output:
  ! 
  ! remarks:
  !    The relevant information concerning the state is included in Ttemp.
  !    The formula for constructing the value is given in Malin/Krueger/Kubler (2007)
  !     equation (11) on pg. 13.
  !

  use Params
  
  implicit none
  
  !Variable Declaration
  real(prec),dimension(2**(q-d)+1,d),intent(in) :: Ttemp
  real(prec),dimension(d,2**(q-d-1)+1),intent(in) :: tempCoeffs1		
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1),intent(in) :: tempCoeffs2		
  real(prec),dimension(d,2**(q-d)+1),intent(in) :: tempCoeffs3		
  real(prec),intent(in) :: ChebValueOrigin

  real(prec) :: ChebValue
  real(prec),dimension(d) :: ChebValue1, ChebValue3
  real(prec),dimension(d-1,d) :: ChebValue2
  integer :: i,j,i1,j1
  
  !Construct 4th order polynomials in each of d dimensions
  ChebValue3 = 0.0
  do i = 1,d
     do j = 1,5		!Note that 5 = 2**(q-d) + 1, since (q-d) = 2
        ChebValue3(i) = tempCoeffs3(i,j)*Ttemp(j,i) + ChebValue3(i) 
     end do
  end do
  
  !Construct 2nd order polynomials in each of d dimensions
  ChebValue1 = 0.0
  do i = 1,d
     do j = 1,3		!Note that 3 = 2**(q-d-1) + 1, since (q-d) = 2
        ChebValue1(i) = tempCoeffs1(i,j)*Ttemp(j,i) + ChebValue1(i) 
     end do
  end do
  
  !Construct 2-dimensional tensor products
  ChebValue2 = 0.0
  do i = 1,d-1
     do i1 = i+1,d
        do j = 1,3		!Note that 3 = 2**(q-d) + 1, since (q-d) = 2
           do j1 = 1,3		!Note that 3 = 2**(q-d) + 1, since (q-d) = 2
              ChebValue2(i,i1) = tempCoeffs2(i,i1,j,j1)*Ttemp(j,i)*Ttemp(j1,i1) + ChebValue2(i,i1)
           enddo
        enddo
     enddo
  enddo
  
  !Constuct ChebValue ... Using formula on pg. 13 of Malin/Krueger/Kubler
  ChebValue = 0.0
  do i = 1,d
     ChebValue = ChebValue3(i) + ChebValue
  enddo
  
  do i = 1,d
     ChebValue = (-1.0)*coc1*ChebValue1(i) + ChebValue
  enddo
  
  do i = 1,d-1
     do i1 = i+1,d
        ChebValue = ChebValue2(i,i1) + ChebValue
     enddo
  enddo
  
  if (d >= 3) then
     ChebValue = coc2*ChebValueOrigin + ChebValue
  endif

end function ChebValue

!****************************************************************************
!
!	MODULE:  Params
!
!	PURPOSE:  Declares and initializes global variables
!			 
!	AUTHOR:	 Ben Malin 
!
!	DATE:  10/2007
!****************************************************************************

module Params
  
  implicit none
  
  integer,parameter :: prec = selected_real_kind(15,307)
  real(prec),parameter :: pie = 3.1415926535897932
  
  !------------------------------
  !Number of 'state' variables
  !------------------------------
  integer,parameter :: N = COUNTRIES 	   !Number of countries  
  integer,parameter :: d = 2*COUNTRIES !2*N!   !Dimension of state space (capital and tech shock)
  integer,parameter :: q = 2*COUNTRIES+2 !d+2!   !In smolyak interpolation algorithm, lambda = q-d

  !----------------------
  !Parameters of model
  !----------------------
  real(prec),parameter :: gamma_min = 0.2
  real(prec),parameter :: gamma_max = 0.4
  real(prec),dimension(N) :: gamma   !Risk aversion (set in ParamUpdate)
  real(prec),dimension(N) :: xgamma  !IES = 1/gamma 
  real(prec),parameter :: Le = 2.5   !Time endowment
  real(prec),parameter :: chi_min = 0.75
  real(prec),parameter :: chi_max = 0.90
  real(prec),dimension(N) :: chi     !elast of subst. cons and leis 
  real(prec),dimension(N) :: xchi    ! = 1/chi
  real(prec),dimension(N) :: ychi    ! = 1-xchi
  real(prec),dimension(N) :: chigam  ! = xchi - xgamma
  real(prec),parameter :: betah = 0.99	!Subjective discount factor
  real(prec),parameter :: alpha = 0.36	!Capital Share
  real(prec),parameter :: muh_min = -0.3
  real(prec),parameter :: muh_max = 0.3
  real(prec),dimension(N) :: muh     !production function parameter 
  real(prec),dimension(N) :: xmuh    ! = 1/muh
  real(prec),parameter :: delta = 0.025	!Depreciation
  real(prec),parameter :: kappa = 0.5	!Adjustment Cost param ("phi" in paper).
  
  real(prec) :: A_tfp = (1-betah)/(alpha*betah)	 !Total Factor Productivity
  real(prec),parameter :: sigma = 0.01	 !variance of tech. shock
  real(prec),parameter :: rho = 0.95     !Persistence of tech. shock
  
  real(prec),dimension(N) :: b    !level of labor supply
  real(prec),dimension(N) :: Pareto    !Pareto weight for each country
  real(prec),dimension(N) :: Lfoc !Parameter in intratemporal equil condition
  
  !--------------------------------
  !Variables for grid subroutine
  !--------------------------------
  real(prec) :: kss	! deterministic steady state capital stock
  real(prec),dimension(N) :: kmax	! used to put upper bound on capital grid
  real(prec),dimension(N) :: kmin	! used to put lower bound on capital grid

  real(prec) :: lss	! deterministic steady state labor supply
  
  real(prec) :: zmax	! largest positive shock is e^(zmax)
  real(prec) :: zmin	! largest negative shock is e^(zmin)
  
  !--------------------------------------------
  !Weights used in formulas for interpolation 
  !--------------------------------------------
  integer :: coc1	!Used in weighted sum of cheb polynomials in Smolyak interpolation
  integer :: coc2	!coc1 is (d-1) choose 1 and coc2 is (d-1) choose 2
  
  !--------------------------------------------------------
  !Variables that hold coefficients of policy functions 
  !--------------------------------------------------------
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsCons3	!Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsCap3    !Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsLab3    !Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsCons1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsCap1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsLab1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsCons2 !Coeffs for 2nd order tensor prods
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsCap2	 !Coeffs for 2nd order tensor prods
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsLab2	 !Coeffs for 2nd order tensor prods
  real(prec),dimension(N) :: yCons0		!Policy function (consumption) evaluated at point0
  real(prec),dimension(N) :: yCap0		!Policy function (capital) evaluated at point0
  real(prec),dimension(N) :: yLab0		!Policy function (labor) evaluated at point0
  
  !--------------------------------
  !General global variables
  !--------------------------------
  integer :: FOCi
  real(prec),dimension(N) :: SimConsumption, SimLabor, SimCapTom, SimOutput
  real(prec),dimension(N) :: SimCapital, shock
  real(prec),dimension(2*N) :: instate
  real(prec),dimension(4*N) :: Results
  
contains
  
  !*************************
  !** Primative Functions **
  !*************************
  
  !-------------------------------------------------------
  ! function Ucc
  !
  !	2nd Derivative wrt consumption of CES 
  !     utility function over consumption and leisure.
  !
  ! Inputs:	c -- real, consumption 
  !             lab -- real, labor
  !             i -- integer, country index
  ! Returns:	real, Ucc
  !
  !-------------------------------------------------------
  
  function Ucc(c,lab,i)
    implicit none
    real(prec) :: Ucc
    real(prec), intent(in) :: c,lab
    integer, intent(in) :: i
    real(prec) :: epsilon, L_upper
    
    epsilon = (10.0)**(-6)
    L_upper = Le - epsilon
    
    if (c >= epsilon .and. lab >= epsilon .and. lab <= L_upper) then
       Ucc = chigam(i) * (c**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i) - 1.0) / c**(2.0*xchi(i)) &
            & - xchi(i) * (c**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i)) / c**(xchi(i) + 1.0)
    elseif (c >= epsilon .and. lab < epsilon) then
       print*, 'lab is below lower bound in Ucc, lab = ', lab
       pause
       Ucc = chigam(i) * (c**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i) - 1.0) & 
            / c**(2.0*xchi(i)) - xchi(i) * (c**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i)) &
            & / c**(xchi(i) + 1.0)
    elseif (c >= epsilon .and. lab > L_upper) then
       print*, 'lab is above upper bound in Ucc, lab = ', lab
       pause
       Ucc = chigam(i) * (c**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i) - 1.0) &
            & / c**(2.0*xchi(i)) - xchi(i) * (c**ychi(i) + b(i)*(Le - & 
            & L_upper)**ychi(i))**(chigam(i)/ychi(i)) / c**(xchi(i) + 1.0)
    elseif (c < epsilon .and. lab < epsilon) then
       print*, 'c is below lower bound in Ucc, c = ', c
       print*, 'lab is below lower bound in Ucc, lab = ', lab
       pause
       Ucc = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i) - 1.0) &
            & / epsilon**(2.0*xchi(i)) - xchi(i) * (epsilon**ychi(i) &
            & + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i)) / epsilon**(xchi(i) + 1.0)
    elseif (c < epsilon .and. lab > L_upper) then
       print*, 'c is below lower bound in Ucc, c = ', c
       print*, 'lab is above upper bound in Ucc, lab = ', lab
       pause
       Ucc = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i) - 1.0) &
            & / epsilon**(2.0*xchi(i)) - xchi(i) * (epsilon**ychi(i) &
            & + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i)) / epsilon**(xchi(i) + 1.0)
    else
       print*, 'c is below lower bound in the function Ucc, c = ', c	
       pause
       Ucc = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i) - 1.0) &
            & / epsilon**(2.0*xchi(i)) - xchi(i) * (epsilon**ychi(i) &
            & + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i)) / epsilon**(xchi(i) + 1.0)
    end if
    
  end function Ucc
  
  !-------------------------------------------------------
  ! function Ucl
  !
  !	2nd Derivative of CES utility function 
  !     over consumption and leisure wrt consumption and 
  !     labor.
  !
  ! Inputs:	c -- real, consumption 
  !             lab -- real, labor
  !             i -- integer, country index
  ! Returns:	real, Ucl
  !
  !-------------------------------------------------------
  
  function Ucl(c,lab,i)
    implicit none
    real(prec) :: Ucl
    real(prec), intent(in) :: c,lab
    integer, intent(in) :: i
    real(prec) :: epsilon, L_upper
    
    epsilon = (10.0)**(-6)
    L_upper = Le - epsilon
    
    if (c >= epsilon .and. lab >= epsilon .and. lab <= L_upper) then
       Ucl = chigam(i) * (c**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i) - 1.0) / c**xchi(i) &
            & * -1.0 * b(i) / (Le-lab)**xchi(i)
    elseif (c >= epsilon .and. lab < epsilon) then
       print*, 'lab is below lower bound in Ucl, lab = ', lab
       pause
       Ucl = chigam(i) * (c**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i) - 1.0) / c**xchi(i) &
            & * -1.0 * b(i) / (Le-epsilon)**xchi(i)
    elseif (c >= epsilon .and. lab > L_upper) then
       print*, 'lab is above upper bound in Ucl, lab = ', lab
       pause
       Ucl = chigam(i) * (c**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i) - 1.0) / c**xchi(i) &
            & * -1.0 * b(i) / (Le-L_upper)**xchi(i)
    elseif (c < epsilon .and. lab < epsilon) then
       print*, 'c is below lower bound in Ucl, c = ', c
       print*, 'lab is below lower bound in Ucl, lab = ', lab
       pause
       Ucl = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i) - 1.0) &
            & / epsilon**xchi(i) * -1.0 * b(i) / (Le-epsilon)**xchi(i)
    elseif (c < epsilon .and. lab > L_upper) then
       print*, 'c is below lower bound in Ucl, c = ', c
       print*, 'lab is above upper bound in Ucl, lab = ', lab
       pause
       Ucl = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i) - 1.0) &
            & / epsilon**xchi(i) * -1.0 * b(i) / (Le-L_upper)**xchi(i)
    else
       print*, 'c is below lower bound in the function Ucl, c = ', c	
       pause
       Ucl = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i) - 1.0) &
            & / epsilon**xchi(i) * -1.0 * b(i) / (Le-lab)**xchi(i)
    end if
    
  end function Ucl
  
  !-------------------------------------------------------
  ! function Ull
  !
  !	2nd Derivative of a CES utility function 
  !     over consumption and leisure wrt labor.
  !
  ! Inputs:	c -- real, consumption 
  !             lab -- real, labor
  !             i -- integer, country index
  ! Returns:	real, Ull
  !
  !-------------------------------------------------------
  
  function Ull(c,lab,i)
    implicit none
    real(prec) :: Ull
    real(prec), intent(in) :: c,lab
    integer, intent(in) :: i
    real(prec) :: epsilon, L_upper
    
    epsilon = (10.0)**(-6)
    L_upper = Le - epsilon
    
    if (c >= epsilon .and. lab >= epsilon .and. lab <= L_upper) then
       Ull = chigam(i) * (c**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i) - 1.0) * b(i)**2.0 / &
            & (Le - lab)**(2.0*xchi(i)) - xchi(i) * b(i) / (Le-lab)**(xchi(i) + 1.0) &
            & * (c**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i))
    elseif (c >= epsilon .and. lab < epsilon) then
       print*, 'lab is below lower bound in Ull, lab = ', lab
       pause
       Ull = chigam(i) * (c**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i) - 1.0) * b(i)**2 &
            & / (Le - epsilon)**(2.0*xchi(i)) - xchi(i) * b(i) / (Le-epsilon)**(xchi(i) + 1.0) &
            & * (c**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i))
    elseif (c >= epsilon .and. lab > L_upper) then
       print*, 'lab is above upper bound in Ull, lab = ', lab
       pause
       Ull = chigam(i) * (c**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i) - 1.0) * b(i)**2 &
            & / (Le - L_upper)**(2.0*xchi(i)) - xchi(i) * b(i) / (Le-L_upper)**(xchi(i) + 1.0) &
            & * (c**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i))
    elseif (c < epsilon .and. lab < epsilon) then
       print*, 'c is below lower bound in Ull, c = ', c
       print*, 'lab is below lower bound in Ull, lab = ', lab
       pause
       Ull = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i) - 1.0) * b(i)**2 &
            & / (Le - epsilon)**(2.0*xchi(i)) - xchi(i) * b(i) / (Le-epsilon)**(xchi(i) + 1.0) &
            & * (epsilon**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i))
    elseif (c < epsilon .and. lab > L_upper) then
       print*, 'c is below lower bound in Ull, c = ', c
       print*, 'lab is above upper bound in Ull, lab = ', lab
       pause
       Ull = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i) - 1.0) * b(i)**2 &
            & / (Le -  L_upper)**(2.0*xchi(i)) - xchi(i) * b(i) / (Le- L_upper)**(xchi(i) + 1.0) &
            & * (epsilon**ychi(i) + b(i)*(Le -  L_upper)**ychi(i))**(chigam(i)/ychi(i))
    else
       print*, 'c is below lower bound in the function Ull, c = ', c	
       pause
       Ull = chigam(i) * (epsilon**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i) - 1.0) * b(i)**2 &
            & / (Le - lab)**(2.0*xchi(i)) - xchi(i) * b(i) / (Le-lab)**(xchi(i) + 1.0) &
            & * (epsilon**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i))
    end if
    
  end function Ull
 
  !-------------------------------------------------------
  ! function Uc
  !
  !	1st Derivative wrt consumption of a CES 
  !     utility function over consumption and leisure.
  !
  ! Inputs:	c -- real, consumption 
  !             lab -- real, labor
  !             i -- integer, country index
  ! Returns:	real, marginal utility of consumption
  !
  !-------------------------------------------------------
  
  function Uc(c,lab,i)
    implicit none
    real(prec) :: Uc
    real(prec), intent(in) :: c,lab
    integer, intent(in) :: i
    real(prec) :: epsilon, L_upper
    
    epsilon = (10.0)**(-6)
    L_upper = Le - epsilon
    
    if (c >= epsilon .and. lab >= epsilon .and. lab <= L_upper) then
       Uc = (c**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i)) / c**xchi(i)
    elseif (c >= epsilon .and. lab < epsilon) then
       print*, 'lab is below lower bound in Uc, lab = ', lab
       pause
       Uc = (c**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i)) / c**xchi(i) &
            & + Ucl(c,epsilon,i)*(lab-epsilon)       
    elseif (c >= epsilon .and. lab > L_upper) then
       print*, 'lab is above upper bound in Uc, lab = ', lab
       pause
       Uc = (c**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i)) / c**xchi(i) &
            & + Ucl(c,L_upper,i)*(lab-L_upper)       
    elseif (c < epsilon .and. lab < epsilon) then
       print*, 'c is below lower bound in Uc, c = ', c
       print*, 'lab is below lower bound in Uc, lab = ', lab
       pause
       Uc = (epsilon**ychi(i) + b(i)*(Le - epsilon)**ychi(i))**(chigam(i)/ychi(i)) / epsilon**xchi(i) &
            & + Ucl(epsilon,epsilon,i)*(lab-epsilon) + Ucc(epsilon,epsilon,i)*(c-epsilon)        
    elseif (c < epsilon .and. lab > L_upper) then
       print*, 'c is below lower bound in Uc, c = ', c
       print*, 'lab is above upper bound in Uc, lab = ', lab
       pause
       Uc = (epsilon**ychi(i) + b(i)*(Le - L_upper)**ychi(i))**(chigam(i)/ychi(i)) / epsilon**xchi(i) &
            & + Ucl(epsilon,L_upper,i)*(lab-L_upper) + Ucc(epsilon,L_upper,i)*(c-epsilon)        
    else
       print*, 'c is below lower bound in the function Uc, c = ', c	
       pause
       Uc = (epsilon**ychi(i) + b(i)*(Le - lab)**ychi(i))**(chigam(i)/ychi(i)) / epsilon**xchi(i) &
            & + Ucc(epsilon,lab,i)*(c-epsilon)        
    end if
    
  end function Uc

  !--------------------------------------------------------
  ! function UlUc
  !
  !	Marginal Rate of Substitution between consumption 
  !     and labor
  !
  ! Inputs:	c -- real, consumption
  !             lab -- real, labor supply
  !             i -- integer, country index
  ! Returns:	real, marginal rate of substitution
  !
  !--------------------------------------------------------
  
  function UlUc(c,lab,i)
    implicit none
    
    real(prec) :: UlUc	
    real(prec), intent(in) :: c
    real(prec), intent(in) :: lab
    integer, intent(in) :: i
    real(prec) :: epsilon, L_upper
    
    epsilon = (10.0)**(-6)
    L_upper = Le - epsilon
    
    if (c >= epsilon .and. lab >= epsilon .and. lab <= L_upper) then
       UlUc = -1.0 * b(i) * (c / (Le - lab))**xchi(i)
    elseif (c >= epsilon .and. lab < epsilon) then
       print*, 'lab is below lower bound in UlUc, lab = ', lab
       pause
       UlUc = -1.0 * b(i) * (c / (Le - epsilon))**xchi(i)
    elseif (c >= epsilon .and. lab > L_upper) then
       print*, 'lab is above upper bound in UlUc, lab = ', lab
       pause
       UlUc = -1.0 * b(i) * (c / (Le - L_upper))**xchi(i)
    elseif (c < epsilon .and. lab < epsilon) then
       print*, 'c is below lower bound in UlUc, c = ', c
       print*, 'lab is below lower bound in UlUc, lab = ', lab
       pause
       UlUc = -1.0 * b(i) * (epsilon / (Le - epsilon))**xchi(i)
    elseif (c < epsilon .and. lab > L_upper) then
       print*, 'c is below lower bound in UlUc, c = ', c
       print*, 'lab is above upper bound in UlUc, lab = ', lab
       pause
       UlUc = -1.0 * b(i) * (epsilon / (Le - L_upper))**xchi(i)
    else
       print*, 'c is below lower bound in the function UlUc, c = ', c	
       pause
       UlUc = -1.0 * b(i) * (epsilon / (Le - lab))**xchi(i)
    end if
    
  end function UlUc

  !------------------------------------------------------------------------------------
  ! function F
  !
  !	Production Function - Takes country-specific capital stock and 
  !	technology shock and returns output.
  !
  ! Inputs:	capital -- real, capital level
  !             lab -- real, labor supply
  !	        sh -- real, technological shock   
  !             i -- integer, country index
  ! Returns:	real, output
  !
  !------------------------------------------------------------------------------------
  
  function F(capital,lab,sh,i)
    implicit none
    real(prec) :: F
    real(prec), intent(in) :: capital,lab,sh
    integer, intent(in) :: i
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (capital >= epsilon .and. lab >= epsilon) then
       F =  A_tfp * exp(sh) * (alpha * capital**muh(i) + (1.0-alpha) * lab**muh(i))**(xmuh(i))
    elseif (capital < epsilon .and. lab >= epsilon) then
       print*, "Error - Capital Stock is negative in F, cap = ", capital	
       pause
       F = 0
    elseif (capital >= epsilon .and. lab < epsilon) then
       print*, "Error - Labor Supply is negative in F, lab = ", lab
       pause
       F = 0
    else
       print*, "Error - Capital Stock is negative in F, cap = ", capital
       print*, "Error - Labor Supply is negative in F, lab = ", lab	
       pause
       F = 0
    end if
  end function F
  
  !----------------------------------------------------------------------------
  ! function Fl
  !
  !	Marginal Product of Labor - Takes country specific capital stock and 
  !	technology shock and returns mpl.
  !
  ! Inputs:	capital -- real, capital level
  !             lab -- real, labor supply
  !		sh -- real, technological shock   
  !             i -- integer, country index
  ! Returns:	real, mpl
  !
  !----------------------------------------------------------------------------
  
  function Fl(capital,lab,sh,i)
    implicit none
    real(prec) :: Fl
    real(prec), intent(in) :: capital,lab,sh
    integer, intent(in) :: i
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (capital >= epsilon .and. lab >= epsilon) then
       Fl = (1.0-alpha) * A_tfp * exp(sh) * (F(capital,lab,sh,i)/(A_tfp*exp(sh)*lab))**(1.0 - muh(i))
    elseif (capital < epsilon .and. lab >= epsilon) then
       print*, "Error - Capital Stock is negative in Fl, cap = ", capital  
       pause
       Fl = (1.0-alpha) * A_tfp * exp(sh) * (F(epsilon,lab,sh,i)/(A_tfp*exp(sh)*lab))**(1.0 - muh(i))
    elseif (capital >= epsilon .and. lab < epsilon) then
       print*, "Error - Labor Supply is negative in Fl, lab = ", lab  
       pause
       Fl = (1.0-alpha) * A_tfp * exp(sh) * (F(capital,epsilon,sh,i)/(A_tfp*exp(sh)*epsilon))**(1.0 - muh(i))
    else
       print*, "Error - Capital Stock is negative in Fl, cap = ", capital  
       print*, "Error - Labor Supply is negative in Fl, lab = ", lab  
       pause
       Fl = (1.0-alpha) * A_tfp * exp(sh) * (F(epsilon,epsilon,sh,i)/(A_tfp*exp(sh)*epsilon))**(1.0 - muh(i))
    end if
    
  end function Fl
  
end module Params

!****************************************************************************
!
!   Program: Main
!
!   Purpose: Runs testing function
!            (uses hybrd.f to solve nonlinear equations)
!
!   Author:  Ben Malin
!
!   Date:    11/2007
!*****************************************************************************
!!$program Main
!!$
!!$  use Params  !Contains global variables/functions
!!$
!!$  implicit none
!!$
!!$  !Variable Declaration
!!$  character(len=6) :: cofile
!!$  character(len=3) :: infile
!!$  character(len=4) :: outfile
!!$
!!$  real(prec),dimension(2*N) :: state
!!$  real(prec),dimension(4*N) :: control
!!$  integer :: i
!!$
!!$  !Sets parameters not initialized in Params
!!$  call ParamUpdate
!!$
!!$  !Read in coefficients of policy functions
!!$  cofile = "coeff2"
!!$  call InCoeffs(cofile)
!!$
!!$  !Read in state variables
!!$  infile = "in1"
!!$  call Input(infile)
!!$  
!!$  !Output
!!$  state = instate  !Note: instate is a global variable.
!!$  call Test(state,control)
!!$  Results = control  !Note: Results is a global variable.
!!$
!!$  !Output results to file
!!$  outfile = "out1"
!!$  call Output(outfile)
!!$
!!$end program Main

!**************************************************************************
!
!    Subroutine:  ParamUpdate
!
!    Purpose:    Constructs country-specific parameters, bounds for state
!                variables, and weights for the interpolation formula.
!**************************************************************************

subroutine ParamUpdate
  
  use Params
  
  implicit none
  
  !Variable Declaration
  integer :: i

 !Constants used in f.o.c. for labor supply
  psi = 1.0/((1.0-alpha) * (Le - 1.0) + 1.0)  
  Lfoc = A_tfp * (1.0-alpha) * psi / (1.0 - psi)
  psigam1 = psi * (1.0 - xgamma)
  psigam2 = (1.0 - psi) * (1.0 - xgamma)

 !Pareto (Negishi) Weights for each country
  lss = 1.0
  do i = 1,N
     Pareto(i) = 1.0 / Uc(A_tfp, lss)
  end do

 !Specify lower and upper bounds for technological shock, e^(z)
  zmin = -0.8 * sigma / (1.0 - rho)    !Note: this may truncate innovations.
  zmax = 0.8 * sigma / (1.0 - rho)
  
 !Compute deterministic steady state (no adjustment costs), 
 !and specify lower and upper bounds for capital stock.
  kss = 1.0
  
  kmin = 0.8*kss
  kmax = 1.2*kss

 !Construct weights for low-dimensional cheb polynomials in smolyak interpolation
  if (d == 2) then
     coc1 = 1
     coc2 = 1
  else 
     coc1 = d-1
     coc2 = (d-1)*(d-2)/2
  endif
 
end subroutine ParamUpdate

!****************************************************************************
!	SUBROUTINE:  InCoeffs
!
!	PURPOSE:  Reads in coefficients for policy rules
!****************************************************************************

subroutine InCoeffs(filename)
  
  ! inputs:
  !   filename -- name of file that contains coefficients for policy rules
  !
  ! output:
  ! 
  ! remarks:

  use Params
  
  implicit none
  
  ! Variable Declaration
  character(len=30), intent(IN) :: filename 
  integer :: i,j,i1,j1

  ! read the data
  !open (1, file = filename//".csv")      ! Open file with name filename
  
  open(unit = 40, file = filename//".csv", status = 'old', action = 'read')
  
  !CoeffsCons3
  do i = 1, d
     do j = 1,N
        read(40,*) CoeffsCons3(i,1,j), CoeffsCons3(i,2,j),CoeffsCons3(i,3,j), & 
             & CoeffsCons3(i,4,j), CoeffsCons3(i,5,j)
     end do
  end do
  !CoeffsCap3
  do i = 1, d
     do j = 1,N
        read(40,*) CoeffsCap3(i,1,j), CoeffsCap3(i,2,j),CoeffsCap3(i,3,j), & 
             & CoeffsCap3(i,4,j), CoeffsCap3(i,5,j)
     end do
  end do
  !CoeffsLab3
  do i = 1, d
     do j = 1,N
        read(40,*) CoeffsLab3(i,1,j), CoeffsLab3(i,2,j),CoeffsLab3(i,3,j), & 
             & CoeffsLab3(i,4,j), CoeffsLab3(i,5,j)
     end do
  end do
  !CoeffsCons1
  do i = 1, d
     do j = 1,N
        read(40,*) CoeffsCons1(i,1,j), CoeffsCons1(i,2,j),CoeffsCons1(i,3,j)
     end do
  end do
  !CoeffsCap1
  do i = 1, d
     do j = 1,N
        read(40,*) CoeffsCap1(i,1,j), CoeffsCap1(i,2,j),CoeffsCap1(i,3,j)
     end do
  end do
  !CoeffsLab1
  do i = 1, d
     do j = 1,N
        read(40,*) CoeffsLab1(i,1,j), CoeffsLab1(i,2,j),CoeffsLab1(i,3,j)
     end do
  end do
  !CoeffsCons2
  do i = 1, d-1
     do i1 = i+1,d
        do j = 1,N
           do j1 = 1,3
              read(40,*) CoeffsCons2(i,i1,1,j1,j), CoeffsCons2(i,i1,2,j1,j), &
                   & CoeffsCons2(i,i1,3,j1,j)
           end do
        end do
     end do
  end do
  !CoeffsCap2
  do i = 1, d-1
     do i1 = i+1,d
        do j = 1,N
           do j1 = 1,3
              read(40,*) CoeffsCap2(i,i1,1,j1,j), CoeffsCap2(i,i1,2,j1,j), &
                   & CoeffsCap2(i,i1,3,j1,j)
           end do
        end do
     end do
  end do
  !CoeffsLab2
  do i = 1, d-1
     do i1 = i+1,d
        do j = 1,N
           do j1 = 1,3
              read(40,*) CoeffsLab2(i,i1,1,j1,j), CoeffsLab2(i,i1,2,j1,j), &
                   & CoeffsLab2(i,i1,3,j1,j)
           end do
        end do
     end do
  end do
  !yCons0
  do i = 1,N
     read(40,*) yCons0(i)
  end do
  !yCap0
  do i = 1,N
     read(40,*) yCap0(i)
  end do
  !yLab0
  do i = 1,N
     read(40,*) yLab0(i)
  end do

  close(40)
  
end subroutine InCoeffs

!****************************************************************************
!	SUBROUTINE:  Input
!
!	PURPOSE:  Reads in state variable
!****************************************************************************

subroutine Input(filename)
  
  ! inputs:
  !   filename -- name of output file
  !
  ! output:
  ! 
  ! remarks:

  use Params		!Contains global variables 
  
  implicit none
  
  ! Variable Declaration
  character(len=3), intent(IN) :: filename 
  integer :: i
  
  ! read the data
  open (1, file = filename//".txt")      ! Open file with name filename
  
  open(unit = 30, file = filename//".txt", status = 'old', action = 'read')
  
  do i = 1, 2*N
     read(30,*) instate(i)
  end do
  
  close(30)
  
end subroutine Input

!*********************************************************************
!
!    Subroutine:  Output
!
!    Purpose:    Produces Output File
!                Writes output to a .csv file.
!*********************************************************************

subroutine Output(filename)

  ! inputs:
  !   filename -- name of output file
  !
  ! output:
  ! 
  ! remarks:
  
  use Params

  implicit none
  
  ! Variable Declaration
  character(len=4), intent(IN) :: filename 
  integer :: i
  
  ! Write output to file
  print*,""
  print*,""
  print*,""
  print*,"Make sure the output file -> ", filename, ".csv <- is closed!"
  print*,""
  print*,""
  print*,""
  
  open (1, file = filename//".csv")      ! Open file with name filename

  !Outputs choice variables: k',c,l,y
  do i = 1,4*N
     write (1, '(F14.7," ")', advance = 'no') Results(i)
     write (1,"()")                                                
  end do

  print*,""
  print*,""
  print*,""
  print*,"Results were written to file -> ", filename, ".csv", " <-"
  print*,""
  print*,""
  print*,""
  
end subroutine Output

!****************************************************************************
!
!	MODULE:  Params
!
!	PURPOSE:  Declares and initializes global variables
!			 
!	AUTHOR:	 Ben Malin 
!
!	DATE:  11/2007
!****************************************************************************

module Params
  
  implicit none
  
  integer,parameter :: prec = selected_real_kind(15,307)
  real(prec),parameter :: pie = 3.1415926535897932
  
  !------------------------------
  !Number of 'state' variables
  !------------------------------
  integer,parameter :: N = COUNTRIES 	   !Number of countries  
  integer,parameter :: d = 2*COUNTRIES !2*N!   !Dimension of state space (capital and tech shock)
  integer,parameter :: q = 2*COUNTRIES+2 !d+2!   !In smolyak interpolation algorithm, lambda = q-d

  !----------------------
  !Parameters of model
  !----------------------
  real(prec),parameter :: gamma = 1.0	! Risk aversion parameter
  real(prec),parameter :: betah = 0.99	! Subjective discount factor
  real(prec),parameter :: alpha = 0.36	! Capital Share
  real(prec),parameter :: delta = 0.025	! Depreciation
  real(prec) :: kappa = 0.5		! Adjustment Cost parameter  ("phi" in paper)

  real(prec) :: A_tfp = (1-betah)/(alpha*betah)	 !Total Factor Productivity
  real(prec),parameter :: sigma = 0.01   !var of tech. shock
  real(prec),parameter :: rho = 0.95     !persistence of tech. shock
  
  real(prec),dimension(N) :: Pareto    !Pareto weight for each country  

  !--------------------------------
  !Variables for grid subroutine
  !--------------------------------
  real(prec) :: kss	! deterministic steady state capital stock
  real(prec) :: kmax	! used to put upper bound on capital grid
  real(prec) :: kmin	! used to put lower bound on capital grid

  real(prec) :: zmax	! largest positive shock is e^(zmax)
  real(prec) :: zmin	! largest negative shock is e^(zmin)
  
  !--------------------------------------------
  !Weights used in formulas for interpolation 
  !--------------------------------------------
  integer :: coc1	!Used in weighted sum of cheb polynomials in Smolyak interpolation
  integer :: coc2	!coc1 is (d-1) choose 1 and coc2 is (d-1) choose 2
  
  !--------------------------------------------------------
  !Variables that hold coefficients of policy functions 
  !--------------------------------------------------------
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsCons3	!Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsCap3    !Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsCons1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsCap1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsCons2 !Coeffs for 2nd order tensor prods
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsCap2	 !Coeffs for 2nd order tensor prods
  real(prec),dimension(N) :: yCons0		!Policy function (consumption) evaluated at point0
  real(prec),dimension(N) :: yCap0		!Policy function (capital) evaluated at point0
  
  !--------------------------------
  !General global variables
  !--------------------------------
  real(prec),dimension(N) :: SimConsumption, SimCapTom, SimOutput
  real(prec),dimension(N) :: SimCapital, shock
  real(prec),dimension(2*N) :: instate
  real(prec),dimension(3*N) :: Results
  
contains
  
  !*************************
  !** Primative Functions **
  !*************************
  
  !-------------------------------------------------------
  ! function Ucc
  !
  !	2nd Derivative of (CRRA) utility function with
  !	coefficient of relative risk aversion 1/gamma
  !
  ! Inputs:	c -- real, consumption 
  ! Returns:	real -- U"(c) 
  !
  !-------------------------------------------------------
  
  function Ucc(c)
    implicit none
    real(prec) Ucc
    real(prec), intent(in) :: c
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (c >= epsilon) then
       Ucc = -1.0/gamma * c**(-1.0/gamma - 1.0)
    else
       print*, 'c is below lower bound in the function Ucc, c = ', c	
       !pause
       Ucc = -1.0/gamma * epsilon**(-1.0/gamma - 1.0)
    end if
    
  end function Ucc
  
  !---------------------------------------------------
  ! function Uc
  !
  !	(CRRA) marginal utility function with
  !	coefficient of relative risk aversion 1/gamma
  !
  ! Inputs:	c -- real, consumption 
  ! Returns:	real, marginal utility 
  !
  !---------------------------------------------------
  
  function Uc(c)
    implicit none
    real(prec) Uc
    real(prec), intent(in) :: c
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (c >= epsilon) then
       Uc = c**(-1.0/gamma)
    else
       print*, 'c is below lower bound in the function Uc, c = ', c
       pause
       Uc = epsilon**(-1.0/gamma) + Ucc(epsilon) * (c - epsilon)
    end if
    
  end function Uc
  
  !------------------------------------------------------------------------------------
  ! function F
  !
  !	Production Function - Takes country specific capital stock and 
  !	technology shock and returns output.
  !
  ! Inputs:	capital -- real, capital level
  !			sh -- real, technological shock   
  ! Returns:	real, output
  !
  !------------------------------------------------------------------------------------
  
  function F(capital,sh)
    implicit none
    real(prec) :: F
    real(prec), intent(in) :: capital, sh
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (capital >= epsilon) then
       F =  A_tfp * exp(sh)*capital**alpha
    else
       print*, "Error - Capital Stock is negative in F, cap = ", capital 
       pause
       F = 0
    end if
    
  end function F
  
  !----------------------------------------------------------------------------
  ! function Fk
  !
  !	Marginal Product of Capital - Takes country specific capital stock and 
  !	technology shock and returns mpk.
  !
  ! Inputs:	capital -- real, capital level
  !			sh -- real, technological shock   
  ! Returns:	real, mpk
  !
  !----------------------------------------------------------------------------
  
  function Fk(capital,sh)
    implicit none
    real(prec) :: Fk
    real(prec), intent(in) :: capital,sh
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (capital >= epsilon) then
       Fk =  A_tfp * alpha*exp(sh)*capital**(alpha-1.0)
    else
       print*, "Error - Capital Stock is negative in Fk, cap = ", capital  
       pause
       Fk =  A_tfp * alpha*exp(sh)*epsilon**(alpha-1.0)
    end if
    
  end function Fk
    
end module Params

!**********************************************************************************
!
!	SUBROUTINE: Test
!
!	PURPOSE: Takes as input state variable and returns as output all variables
!                 for the current period.
!			 
!	AUTHOR:	 Ben Malin 
!
!	DATE:    11/2007
!**********************************************************************************

subroutine Test(state,control)
  
  ! inputs:
  !   state -- vector of dimension 2*N, contains state variables k and ln(a)
  !
  ! output:
  !   control -- vector of dimension 4*N, contains k', c, l, and y 
  !
  ! remarks:
  !
  
  use Params

  implicit none
  
  !Variable Declarations
  real(prec),dimension(2*N),intent(in) :: state
  real(prec),dimension(4*N),intent(out) :: control
  integer :: i,j	
  real(prec),dimension(5,2*N) :: Ttemp
 
  !Function used to calculate optimal policy functions (either consumption or capital) given state 
  real(prec),external :: ChebValue

  !Subroutines called by nonlinear equation solver
  external :: AConsLabOne
  external :: AConsLabOther

  !Variables used in nonlinear equation solver to solve for country 1's labor supply
  integer, parameter :: itmaxA = 300
  integer, parameter :: countA = 1
  real(prec) :: RelerrA, fnormA
  real(prec), dimension(countA) :: guessA, finalA, fvecA
  
  !Variables used in nonlinear equation solver to solve for cons and labor of countries 2-N
  integer, parameter :: itmaxB = 300
  integer, parameter :: countB = 2
  real(prec) :: RelerrB, fnormB
  real(prec), dimension(countB) :: guessB, finalB, fvecB

  ! Variables required by HYBRD
  real(prec), parameter :: epsfcn = 1E-16
  integer, dimension(countA) :: diagA 
  integer, dimension(countB) :: diagB
  integer, parameter :: mode = 1
  real(prec), parameter :: factor = 100.0
  integer, parameter :: nprint = 0
  integer :: info, nfev, iflag
  real(prec), dimension(countA,countA) :: fjacA
  real(prec), dimension(countB,countB) :: fjacB
  integer :: lrA, lrB
  real(prec), dimension(:), allocatable :: rA, rB
  real(prec), dimension(countA) :: qtfA, wa1A, wa2A, wa3A, wa4A
  real(prec), dimension(countB) :: qtfB, wa1B, wa2B, wa3B, wa4B

  !Initialize inputs to nle solver, DNEQNF
  RelerrA = 0.0000001
  fnormA = 0
  guessA = 1.0
  finalA = 1.0
  lrA = countA*(countA+1)/2  
  allocate(rA(lrA))

  !Initialize inputs to nle solver, DNEQNF
  RelerrB = 0.0000001
  fnormB = 0
  guessB(1) = A_tfp
  guessB(2) = 1.0
  !finalB = 1.0
  finalB(1) = A_tfp
  finalB(2) = 1.0
  lrB = countB*(countB+1)/2  
  allocate(rB(lrB))

  iflag = 0

  !Read in state variables
  do i = 1,N
     SimCapital(i) = state(i)
     shock(i) = state(N+i)
  end do
  call ChebPoly(d, state, Ttemp)

  !Compute labor supply and consumption of country 1
  SimConsumption(1) = ChebValue(Ttemp,CoeffsCons1(:,:,1), &
       & CoeffsCons2(:,:,:,:,1),CoeffsCons3(:,:,1),YCons0(1))
  !  guessA = lss
  !  call DNEQNF(AConsLabOne, RelerrA, countA, itmaxA, guessA, finalA, fnormA)
  finalA = lss
  call HYBRD(AConsLabOne,countA,finalA,fvecA,RelerrA,itmaxA,countA,countA, &
       & epsfcn,diagA,mode,factor,nprint,info,nfev,fjacA,countA,rA,lrA,qtfA, &
       & wa1A,wa2A,wa3A,wa4A)
  SimLabor(1) = finalA(1)
  SimOutput(1) = F(SimCapital(1),SimLabor(1),shock(1))
  
  do i = 1,N
     SimCapTom(i) = ChebValue(Ttemp,CoeffsCap1(:,:,i), &
          & CoeffsCap2(:,:,:,:,i),CoeffsCap3(:,:,i),YCap0(i))
  enddo
  !Compute consumption, labor supply and output of countries 2 - N.
  do FOCi = 2,N
!     guessB(1) = log(SimConsumption(1))
!     guessB(2) = SimLabor(1)
!     call DNEQNF(AConsLabOther, RelerrB, countB, itmaxB, guessB, finalB, fnormB)
     finalB(1) = log(SimConsumption(1))
     finalB(2) = SimLabor(1)
     call HYBRD(AConsLabOther,countB,finalB,fvecB,RelerrB,itmaxB,countB,countB, &
          & epsfcn,diagB,mode,factor,nprint,info,nfev,fjacB,countB,rB,lrB,qtfB, &
          & wa1B,wa2B,wa3B,wa4B)
     SimConsumption(FOCi) = exp(finalB(1))
     SimLabor(FOCi) = finalB(2)
     SimOutput(FOCi) = F(SimCapital(FOCi),SimLabor(FOCi),shock(FOCi))
  end do
    
  do i = 1,N
     control(i) = SimCapTom(i)
     control(N+i) = SimConsumption(i)
     control(2*N+i) = SimLabor(i)
     control(3*N+i) = SimOutput(i)
  end do

end subroutine Test

!**********************************************************************************
!
!	SUBROUTINE:  ChebPoly
!
!	PURPOSE: Converts a vector of state variables from the [kmin,kmax] x N grid (or 
!                 [kmin,kmax]/[zmin,zmax] x d grid) to the [-1,1] x N (or d) grid 
!                and returns the Chebyshev polynomials for these state variables.
!                This subroutine works in conjunction with ChebValue.
!**********************************************************************************

subroutine ChebPoly(dim1,state,Ttemp)
  
  ! inputs:
  !    dim1 -- dimension of "state" vector
  !    state -- vector of capital stocks and, possibly, technology shocks
  !
  ! output:
  !    Ttemp -- Chebyshev polynomials evaluated at points in state vector
  ! 
  ! remarks:
  !

  use Params
  
  implicit none
  
  !Variable Declaration
  integer, intent(in) :: dim1
  real(prec), dimension(dim1), intent(in) :: state
  real(prec), dimension(2**(q-d)+1,dim1), intent(out) :: Ttemp
  real(prec), dimension(dim1) :: newstate
  integer :: i,j
  
  do i = 1,N
     !Convert capital stock [-1,1] grid
     newstate(i) = 2.0 * (state(i) - kmin)/(kmax-kmin) - 1.0	!kmax, kmin are global variables
     
!     if (newstate(i) < -1) then
!        print*, 'error: capital below kmin in function ChebPoly',i
!        !pause
!     elseif (newstate(i) > 1) then
!        print*, 'error: capital above kmax in function ChebPoly',i
!        !pause
!     end if
     
     !Construct Chebyshev Polynomials for capital stocks
     Ttemp(1,i) = 1
     Ttemp(2,i) = newstate(i)
     do j = 3,5			!Since q = d+2, 2**(q-d)+1 = 5.
        Ttemp(j,i) = 2.0 * newstate(i) * Ttemp(j-1,i) - Ttemp(j-2,i)
     end do
     
     !Convert technological shocks to [-1,1] grid
     if (dim1 == d) then
        newstate(i+N) = 2.0 * (state(i+N) - zmin)/(zmax-zmin) - 1.0	!zmax, zmin are global variables
        
!        if (newstate(i+N) < -1) then
!           print*, 'error: tech shock below zmin in function ChebPoly'
!           !pause
!        elseif (newstate(i+N) > 1) then
!           print*, 'error: tech shock above zmax in function ChebPoly'
!           !pause
!        end if
        
        !Construct Chebyshev Polynomials for tech shocks
        Ttemp(1,i+N) = 1
        Ttemp(2,i+N) = newstate(i+N)
        do j = 3,5	!Since q = d+2, 2**(q-d)+1 = 5.
           Ttemp(j,i+N) = 2.0 * newstate(i+N) * Ttemp(j-1,i+N) - Ttemp(j-2,i+N)
        end do
     endif
  end do
  
end subroutine ChebPoly

!**********************************************************************************
!
!	FUNCTION:  ChebValue
!
!	PURPOSE: Given the state variables, returns the value of the 
!                 policy function.
!**********************************************************************************

function ChebValue(Ttemp,tempCoeffs1,tempCoeffs2,tempCoeffs3,ChebValueOrigin)
  
  ! inputs:
  !    Ttemp -- Chebyshev polynomials of state variables
  !    tempCoeffs1 -- coefficients of policy function
  !    tempCoeffs2 -- coefficients of policy function
  !    tempCoeffs3 -- coefficients of policy function
  !    ChebValueOrigin -- coefficient of policy function
  !
  ! output:
  ! 
  ! remarks:
  !    The relevant information concerning the state is included in Ttemp.
  !    The formula for constructing the value is given in Malin/Krueger/Kubler (2007)
  !     equation (11) on pg. 13.
  !

  use Params
  
  implicit none
  
  !Variable Declaration
  real(prec),dimension(2**(q-d)+1,d),intent(in) :: Ttemp
  real(prec),dimension(d,2**(q-d-1)+1),intent(in) :: tempCoeffs1		
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1),intent(in) :: tempCoeffs2		
  real(prec),dimension(d,2**(q-d)+1),intent(in) :: tempCoeffs3		
  real(prec),intent(in) :: ChebValueOrigin

  real(prec) :: ChebValue
  real(prec),dimension(d) :: ChebValue1, ChebValue3
  real(prec),dimension(d-1,d) :: ChebValue2
  integer :: i,j,i1,j1
  
  !Construct 4th order polynomials in each of d dimensions
  ChebValue3 = 0.0
  do i = 1,d
     do j = 1,5		!Note that 5 = 2**(q-d) + 1, since (q-d) = 2
        ChebValue3(i) = tempCoeffs3(i,j)*Ttemp(j,i) + ChebValue3(i) 
     end do
  end do
  
  !Construct 2nd order polynomials in each of d dimensions
  ChebValue1 = 0.0
  do i = 1,d
     do j = 1,3		!Note that 3 = 2**(q-d-1) + 1, since (q-d) = 2
        ChebValue1(i) = tempCoeffs1(i,j)*Ttemp(j,i) + ChebValue1(i) 
     end do
  end do
  
  !Construct 2-dimensional tensor products
  ChebValue2 = 0.0
  do i = 1,d-1
     do i1 = i+1,d
        do j = 1,3		!Note that 3 = 2**(q-d) + 1, since (q-d) = 2
           do j1 = 1,3		!Note that 3 = 2**(q-d) + 1, since (q-d) = 2
              ChebValue2(i,i1) = tempCoeffs2(i,i1,j,j1)*Ttemp(j,i)*Ttemp(j1,i1) + ChebValue2(i,i1)
           enddo
        enddo
     enddo
  enddo
  
  !Constuct ChebValue ... Using formula on pg. 13 of Malin/Krueger/Kubler
  ChebValue = 0.0
  do i = 1,d
     ChebValue = ChebValue3(i) + ChebValue
  enddo
  
  do i = 1,d
     ChebValue = (-1.0)*coc1*ChebValue1(i) + ChebValue
  enddo
  
  do i = 1,d-1
     do i1 = i+1,d
        ChebValue = ChebValue2(i,i1) + ChebValue
     enddo
  enddo
  
  if (d >= 3) then
     ChebValue = coc2*ChebValueOrigin + ChebValue
  endif

end function ChebValue

!*****************************************************************************
!
!	SUBROUTINE:  AConsLabOne
!
!	PURPOSE: Specifies equation whose solution is country-1 labor supply.
!*****************************************************************************

subroutine AConsLabOne(countA,ls,mrsmpl,iflag)
  
  ! inputs:
  !    ls -- Holds guess of nonlinear equation solver
  !    countA -- size of pol vector (1)
  !
  ! output:
  !    mrsmpl -- value of equation evaluated at ls
  ! 
  ! remarks:
  !    ls(1) will be the labor supply of country 1.
  !
  
  use Params
  
  implicit none
  
  !Variable Declaration
  integer,intent(in) :: countA, iflag	
  real(prec),dimension(countA),intent(in) :: ls	
  real(prec),dimension(countA),intent(out) :: mrsmpl
  
  real(prec) :: epsilon = 10.0**(-6)
  real(prec), dimension(countA) :: lstemp
  real(prec) :: BigNumb = 100
  
  !Make sure nle solver's guess for labor supply is in-bounds
  if (ls(1) < epsilon) then
     !print*, 'error: labor supply below epsilon in AConsLabOne'
     !pause
     lstemp(1) = epsilon    !Sets labor supply at the boundary
  elseif (ls(1) > Le) then
     !print*, 'error: labor supply above endowment in AConsLabOne '
     !pause
     lstemp(1) = Le - epsilon    !Sets labor supply near boundary
  else
     lstemp(1) = ls(1)
  endif
  

  mrsmpl(1) = UlUc(SimConsumption(1),lstemp(1)) + &
       & FL(SimCapital(1),lstemp(1),shock(1))

  !Penalty if guess for labor supply is out-of-bounds
  if (ls(1) < epsilon) then
     !print*, mrsmpl(1)
     mrsmpl(1) = mrsmpl(1) - (ls(1) - epsilon) * BigNumb
     !print*, mrsmpl(1), ls(1)
  elseif (ls(1) > Le) then
     !print*, mrsmpl(1)
     mrsmpl(1) = mrsmpl(1) - (ls(1) - Le + epsilon) * BigNumb
     !print*, mrsmpl(1), ls(1)
  endif
  
end subroutine AConsLabOne

!*****************************************************************************
!
!	SUBROUTINE:  AConsLabOther
!
!	PURPOSE: Specifies system of 2 equations whose solution is 
!               country-i consumption and labor supply.
!*****************************************************************************

subroutine AConsLabOther(countB,polcl,StatFOC,iflag)
  
  ! inputs:
  !    polcl -- Holds guess of nonlinear equation solver
  !    countB -- size of polcl vector (2)
  !
  ! output:
  !    StatFOC -- value of equations evaluated at polcl
  ! 
  ! remarks:
  !    polcl(1) will be consumption of country i
  !    polcl(2) will be the labor supply of country i
  !
  
  use Params
  
  implicit none
  
  !Variable Declaration
  integer,intent(in) :: countB, iflag    !countB == 2
  real(prec),dimension(countB),intent(in) :: polcl	
  real(prec),dimension(countB),intent(out) :: StatFOC
  
  real(prec) :: epsilon = 10.0**(-6)
  real(prec), dimension(countB) :: poltemp
  real(prec) :: BigNumb = 100

  !Make sure nle solver's guesses for labor supply and cons are in-bounds
  poltemp(1) = exp(polcl(1))
  if (polcl(2) < epsilon) then
     !print*, 'error: labor supply below epsilon in AConsLabOther'
     !pause
     poltemp(2) = epsilon    !Sets labor supply at the boundary
  elseif (polcl(2) > Le) then
     !print*, 'error: labor supply above endowment in AConsLabOther'
     !pause
     poltemp(2) = Le - epsilon   !Sets labor supply near boundary
  else
     poltemp(2) = polcl(2)
  endif
  
  !FOC for consumption smoothing
  StatFOC(1) = Pareto(1) * Uc(SimConsumption(1),SimLabor(1)) & 
       & - Pareto(FOCi) * Uc(poltemp(1),poltemp(2))
  
  !FOC for labor supply
  StatFOC(2) = UlUc(poltemp(1),poltemp(2)) & 
       & + FL(SimCapital(FOCi),poltemp(2),shock(FOCi))
  
  !Penalty if guess for labor supply is out-of-bounds
  if (polcl(2) < epsilon) then
     !print*, StatFOC(2)
     StatFOC(2) = StatFOC(2) - (polcl(2) - epsilon) * BigNumb
     !print*, StatFOC(2), polcl(2)
  elseif (polcl(2) > Le) then
     !print*, StatFOC(2)
     StatFOC(2) = StatFOC(2) - (polcl(2) - Le + epsilon) * BigNumb
     !print*, StatFOC(2), polcl(2)
  endif
  
end subroutine AConsLabOther

!****************************************************************************
!
!	MODULE:  Params
!
!	PURPOSE:  Declares and initializes global variables
!			 
!	AUTHOR:	 Ben Malin 
!
!	DATE:  11/2007
!****************************************************************************

module Params
  
  implicit none
  
  integer,parameter :: prec = selected_real_kind(15,307)
  real(prec),parameter :: pie = 3.1415926535897932
  
  !------------------------------
  !Number of 'state' variables
  !------------------------------
  integer,parameter :: N = COUNTRIES 	   !Number of countries  
  integer,parameter :: d = 2*COUNTRIES !2*N!   !Dimension of state space (capital and tech shock)
  integer,parameter :: q = 2*COUNTRIES+2 !d+2!   !In smolyak interpolation algorithm, lambda = q-d

  !----------------------
  !Parameters of model
  !----------------------
  real(prec),parameter :: gamma = 0.25	!Risk aversion parameter
  real(prec) :: xgamma = 1.0/gamma      !Intertemporal Elasticity of Substitution
  real(prec),parameter :: eta = 0.1     !Labor supply elasticity parameter
  real(prec) :: xeta = 1.0/eta          !Frisch elasticity of labor supply
  real(prec),parameter :: betah = 0.99	!Subjective discount factor
  real(prec),parameter :: alpha = 0.36	!Capital Share
  real(prec),parameter :: delta = 0.025	!Depreciation
  real(prec) :: kappa = 0.5		!Adjustment Cost parameter  ("phi" in paper)
  
  real(prec) :: A_tfp = (1-betah)/(alpha*betah)	 !Total Factor Productivity
  real(prec),parameter :: sigma = 0.01	 !var of tech. shock
  real(prec),parameter :: rho = 0.95     !Persistence of tech. shock
  
  real(prec),dimension(N) :: Pareto    !Pareto weights for each of N countries (set in Grid)

  real(prec) :: b   !Utility parameter for labor
  real(prec) :: Lfoc !Parameter in intratemporal first order condition
  real(prec) :: Lelast !Used in intratemporal first order condition
  
  !--------------------------------
  !Variables for grid subroutine
  !--------------------------------
  real(prec) :: kss	! deterministic steady state capital stock
  real(prec) :: kmax	! used to put upper bound on capital grid
  real(prec) :: kmin	! used to put lower bound on capital grid

  real(prec) :: lss	! deterministic steady state labor supply
  
  real(prec) :: zmax	! largest positive shock is e^(zmax)
  real(prec) :: zmin	! largest negative shock is e^(zmin)
  
  !--------------------------------------------
  !Weights used in formulas for interpolation 
  !--------------------------------------------
  integer :: coc1	!Used in weighted sum of cheb polynomials in Smolyak interpolation
  integer :: coc2	!coc1 is (d-1) choose 1 and coc2 is (d-1) choose 2
  
  !--------------------------------------------------------
  !Variables that hold coefficients of policy functions 
  !--------------------------------------------------------
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsCons3	!Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsCap3    !Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d)+1,N) :: CoeffsLab3    !Coeffs for 4th order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsCons1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsCap1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d,2**(q-d-1)+1,N) :: CoeffsLab1	!Coeffs for 2nd order polynomials for each of d dims
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsCons2 !Coeffs for 2nd order tensor prods
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsCap2	 !Coeffs for 2nd order tensor prods
  real(prec),dimension(d-1,d,2**(q-d-1)+1,2**(q-d-1)+1,N) :: CoeffsLab2	 !Coeffs for 2nd order tensor prods
  real(prec),dimension(N) :: yCons0		!Policy function (consumption) evaluated at point0
  real(prec),dimension(N) :: yCap0		!Policy function (capital) evaluated at point0
  real(prec),dimension(N) :: yLab0		!Policy function (labor) evaluated at point0
  
  !--------------------------------
  !General global variables
  !--------------------------------
  integer :: FOCi
  real(prec),dimension(N) :: SimConsumption, SimLabor, SimCapTom, SimOutput
  real(prec),dimension(N) :: SimCapital, shock
  real(prec),dimension(2*N) :: instate
  real(prec),dimension(4*N) :: Results
  
contains
  
  !*************************
  !** Primative Functions **
  !*************************
  
  !-------------------------------------------------------
  ! function Ucc
  !
  !	2nd Derivative of (CRRA) utility function with
  !	coefficient of relative risk aversion 1/gamma
  !
  ! Inputs:	c -- real, consumption 
  ! Returns:	real -- U"(c) 
  !
  !-------------------------------------------------------
  
  function Ucc(c)
    implicit none
    real(prec) :: Ucc
    real(prec), intent(in) :: c
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (c < epsilon) then
       print*, 'c is below lower bound in the function Ucc, c = ', c	
       !pause
       Ucc = -xgamma * epsilon**(-xgamma - 1.0)
    else
       Ucc = -xgamma * c**(-xgamma - 1.0)
    end if
    
  end function Ucc
  
  !---------------------------------------------------
  ! function Uc
  !
  !	(CRRA) marginal utility function with
  !	coefficient of relative risk aversion 1/gamma
  !
  ! Inputs:	c -- real, consumption 
  ! Returns:	real, marginal utility 
  !
  !---------------------------------------------------
  
  function Uc(c)
    implicit none
    real(prec) :: Uc
    real(prec), intent(in) :: c
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (c < epsilon) then
       print*, 'c is below lower bound in the function Uc, c = ', c
       pause
       Uc = epsilon**(-xgamma) + Ucc(epsilon) * (c - epsilon)
    else
       Uc = c**(-xgamma)
    end if
    
  end function Uc
  
  !-------------------------------------------------------
  ! function Ull
  !
  !	2nd Derivative of (CRRA) utility function wrt
  !	labor
  !
  ! Inputs:	lab -- real, labor supply 
  ! Returns:	real -- U"(lab) 
  !
  !-------------------------------------------------------
  
  function Ull(lab)
    implicit none
    real(prec) :: Ull
    real(prec), intent(in) :: lab
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (lab < epsilon) then
       print*, 'lab below lower bound in the function Ull, lab = ', lab	
       !pause
       Ull = -b * xeta * epsilon**(xeta - 1.0)
    else
       Ull = -b * xeta * lab**(xeta - 1.0)
    end if
    
  end function Ull
  
  !--------------------------------------------------------
  ! function UlUc
  !
  !	Marginal Rate of Substitution between consumption 
  !     and labor
  !
  ! Inputs:	c -- real, consumption
  !             lab -- real, labor supply
  ! Returns:	real, marginal rate of substitution
  !
  !--------------------------------------------------------
  
  function UlUc(c,lab)
    implicit none
    
    real(prec) :: UlUc	
    real(prec), intent(in) :: c
    real(prec), intent(in) :: lab
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (c < epsilon .and. lab < epsilon) then
       print*, "Error - consumption below lower bound in UlUc, c = ", c
       print*, "Error - labor below lower bound in UlUc, l = ", lab
       pause
       UlUc = -1.0 * (-b * epsilon**(xeta) + Ull(epsilon) * (lab - epsilon)) * &
            & (epsilon**(-xgamma) + Ucc(epsilon) * (c - epsilon))**(-1.0)
    elseif (c < epsilon .and. lab >= epsilon) then
       print*, "Error - consumption below lower bound in UlUc, c = ", c
       pause
       UlUc = b * lab**(xeta)  * &
            & (epsilon**(-xgamma) + Ucc(epsilon) * (c - epsilon))**(-1.0)
    elseif (c >= epsilon .and. lab < epsilon) then
       print*, "Error - labor below lower bound in UlUc, l = ", lab
       pause
       UlUc = -1.0 * (-b * epsilon**(xeta) + Ull(epsilon) * (lab - epsilon)) * &
            & c**(xgamma)
    else
       UlUc = b * lab**(xeta) * c**(xgamma)
    end if

  end function UlUc

  !------------------------------------------------------------------------------------
  ! function F
  !
  !	Production Function - Takes country-specific capital stock and 
  !	technology shock and returns output.
  !
  ! Inputs:	capital -- real, capital level
  !             lab -- real, labor supply
  !	        sh -- real, technological shock   
  ! Returns:	real, output
  !
  !------------------------------------------------------------------------------------
  
  function F(capital,lab,sh)
    implicit none
    real(prec) :: F
    real(prec), intent(in) :: capital,lab,sh
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (capital >= epsilon .and. lab >= epsilon) then
       F =  A_tfp * exp(sh) * capital**alpha * lab**(1.0-alpha)
    elseif (capital < epsilon .and. lab >= epsilon) then
       print*, "Error - Capital Stock is negative in F, cap = ", capital 
       pause
       F = 0
    elseif (capital >= epsilon .and. lab < epsilon) then
       print*, "Error - Labor is negative in F, lab = ", lab 
       pause
       F = 0
    else
       print*, "Error - Capital Stock is negative in F, cap = ", capital 
       print*, "Error - Labor is negative in F, lab = ", lab 
       pause
       F = 0
    end if
    
  end function F
  
  !----------------------------------------------------------------------------
  ! function Fk
  !
  !	Marginal Product of Capital - Takes country specific capital stock and 
  !	technology shock and returns mpk.
  !
  ! Inputs:	capital -- real, capital level
  !             lab -- real, labor supply
  !		sh -- real, technological shock   
  ! Returns:	real, mpk
  !
  !----------------------------------------------------------------------------
  
  function Fk(capital,lab,sh)
    implicit none
    real(prec) :: Fk
    real(prec), intent(in) :: capital,lab,sh
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (capital >= epsilon .and. lab >= epsilon) then
       Fk =  alpha * A_tfp * exp(sh) * (capital/lab)**(alpha-1.0)
    elseif (capital < epsilon .and. lab >= epsilon) then
       print*, "Error - Capital Stock is negative in Fk, cap = ", capital  
       pause
       Fk =  alpha * A_tfp * exp(sh) * epsilon**(alpha-1.0) * lab**(1.0-alpha)
    elseif (capital >= epsilon .and. lab < epsilon) then
       print*, "Error - Labor Supply is negative in Fk, lab = ", lab  
       pause
       Fk =  alpha * A_tfp * exp(sh) * capital**(alpha-1.0) * epsilon**(1.0-alpha)
    else
       print*, "Error - Capital Stock is negative in Fk, cap = ", capital  
       print*, "Error - Labor Supply is negative in Fk, lab = ", lab  
       pause
       Fk =  alpha * A_tfp * exp(sh) * epsilon**(alpha-1.0) * epsilon**(1.0-alpha)
    end if
    
  end function Fk
  
  !----------------------------------------------------------------------------
  ! function Fl
  !
  !	Marginal Product of Labor - Takes country specific capital stock and 
  !	technology shock and returns mpl.
  !
  ! Inputs:	capital -- real, capital level
  !             lab -- real, labor supply
  !		sh -- real, technological shock   
  ! Returns:	real, mpl
  !
  !----------------------------------------------------------------------------
  
  function Fl(capital,lab,sh)
    implicit none
    real(prec) :: Fl
    real(prec), intent(in) :: capital,lab,sh
    real(prec) :: epsilon
    
    epsilon = (10.0)**(-6)
    
    if (capital >= epsilon .and. lab >= epsilon) then
       Fl = (1.0-alpha) * A_tfp * exp(sh) * (capital/lab)**(alpha) 
    elseif (capital < epsilon .and. lab >= epsilon) then
       print*, "Error - Capital Stock is negative in Fl, cap = ", capital  
       pause
       Fl = (1.0-alpha) * A_tfp * exp(sh) * epsilon**(alpha) * lab**(-alpha)
    elseif (capital >= epsilon .and. lab < epsilon) then
       print*, "Error - Labor Supply is negative in Fl, lab = ", lab  
       pause
       Fl = (1.0-alpha) * A_tfp * exp(sh) * capital**(alpha) * epsilon**(-alpha)
    else
       print*, "Error - Capital Stock is negative in Fl, cap = ", capital  
       print*, "Error - Labor Supply is negative in Fl, lab = ", lab  
       pause
       Fl = (1.0-alpha) * A_tfp * exp(sh) * epsilon**(alpha) * epsilon**(-alpha)
    end if
    
  end function Fl
  
end module Params
